*////////////////////////////////////////////////////
*// View test:
*//    CURSORTOXML(dbf) vs LENC(FILETOSTR(dbf))
*// in selected folder
*// VFP ver: 8.0(SP1VFP8), 7.0(SP1VFP7)
*//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*// Author:  Michael Drozdov
*// My Page: http://vfpdev.narod.ru/
*// Date:    03/01/2004
*//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#DEFINE C_PATH_DATA			HOME(2)+'Data\'
*#DEFINE C_PATH_DATA		HOME(2)+'\Tastrade\Data\'
#DEFINE C_RESULT_DATA		"result"
#DEFINE C_CLS_SESSION		"DbfVsXml"
#DEFINE C_CLS_FORM			"frmShowResult"
#DEFINE C_PROGID_MSCHART 	"MsChart20Lib.MsChart"
#DEFINE C_FRM_CAPTION		"DBF vs XML"
#DEFINE N_XML_FORMAT		3
#DEFINE N_XML_FLAGS			1+16

#DEFINE VtChLocationTypeTopLeft		0	&& Top left
#DEFINE VtChLocationTypeTop			1	&& Top
#DEFINE VtChLocationTypeTopRight	2	&& Top right
#DEFINE VtChLocationTypeLeft		3	&& Left
#DEFINE VtChLocationTypeRight		4	&& Right
#DEFINE VtChLocationTypeBottomLeft	5	&& Bottom left
#DEFINE VtChLocationTypeBottomRight	7	&& Bottom right
#DEFINE VtChLocationTypeCustom		8	&& Custom

#DEFINE VtChChartType3dBar				0	&& 3d Bar
#DEFINE VtChChartType2dBar				1	&& 2d Bar
#DEFINE VtChChartType3dLine				2	&& 3d Line
#DEFINE VtChChartType2dLine				3	&& 2d Line
#DEFINE VtChChartType3dArea				4	&& 3d Area
#DEFINE VtChChartType2dArea				5	&& 2d Area
#DEFINE VtChChartType3dStep				6	&& 3d Step
#DEFINE VtChChartType2dStep				7	&& 2d Step
#DEFINE VtChChartType3dCombination		8	&& 3d Combination
#DEFINE VtChChartType2dCombination		9	&& 2d Combination
#DEFINE VtChChartType3dHorizontalBar	10	&& 3d Horizontal Bar
#DEFINE VtChChartType2dHorizontalBar	11	&& 2d Horizontal Bar
#DEFINE VtChChartType3dClusteredBar		12	&& 3d Clustered Bar
#DEFINE VtChChartType3dPie				13	&& 3d Pie
#DEFINE VtChChartType2dPie				14	&& 2d Pie
#DEFINE VtChChartType3dDoughnut			15	&& 3d Doughnut
#DEFINE VtChChartType2dXY				16	&& 2d XY
#DEFINE VtChChartType2dPolar			17	&& 2d Polar
#DEFINE VtChChartType2dRadar			18	&& 2d Radar
#DEFINE VtChChartType2dBubble			19	&& 2d Bubble
#DEFINE VtChChartType2dHiLo				20	&& 2d HiLo
#DEFINE VtChChartType2dGantt			21	&& 2d Gantt
#DEFINE VtChChartType3dGantt			22	&& 3d Gantt
#DEFINE VtChChartType3dSurface			23	&& 3d Surface
#DEFINE VtChChartType2dContour			24	&& 2d Contour
#DEFINE VtChChartType3dScatter			25	&& 3d Scatter
#DEFINE VtChChartType3dXYZ				26	&& 3d XYZ

#DEFINE N_CUR_CHARTYPE		VtChChartType2dBar
#DEFINE N_CUR_LOCATIONTYPE	VtChLocationTypeTop

IF TYPE('goFrm') # 'O' OR ISNULL(goFrm)
	CLOSE DATABASES ALL 
	RELEASE goFrm
	PUBLIC goFrm
	goFrm = NEWOBJECT(C_CLS_FORM)
	IF VARTYPE(goFrm) # 'O'
		MESSAGEBOX("Can not create object: '" ;
			+ C_CLS_FORM + "'", 16, _SCREEN.Caption)
		RELEASE goFrm
		RETURN .F.
	ENDIF
ENDIF	
goFrm.Show()
	
DEFINE CLASS frmShowResult AS form

	Name = "frmShowResult"
	Top = 0
	Left = 0
	Height = 135
	Width = 275
	oSession = NULL
	cPath = ""
	nMinHeight = (this.Height)
	nMinWidth = (this.Width)
	Caption = C_FRM_CAPTION
	Width = 2*SYSMETRIC(21)/3   
	Height = 2*SYSMETRIC(22)/3
	AutoCenter = .T.  

	ADD OBJECT cmdChangeDir AS commandbutton WITH ;
		Top = 0, ;
		Left = 2, ;
		Height = 36, ;
		Width = 120, ;
		FontSize = 8, ;
		Caption = "Change Directory...", ;
		Name = "cmdChangeDir"


	ADD OBJECT cmdExit AS commandbutton WITH ;
		Top = 0, ;
		Left = 144, ;
		Height = 36, ;
		Width = 120, ;
		FontSize = 8, ;
		Caption = "Close", ;
		Name = "cmdExit"


	ADD OBJECT olecontrol1 AS olecontrol WITH ;
		Top = 48, ;
		Left = 12, ;
		Height = 76, ;
		Width = 253, ;
		OleClass = C_PROGID_MSCHART, ;
		Name = "Olecontrol1"


	PROCEDURE IsMsChart
		IF TYPE('ThisForm.Olecontrol1') # 'O' OR ISNULL(.Olecontrol1)
			MESSAGEBOX("Not found object: '" ;
				+ 'ThisForm.Olecontrol1' + "'", 16, .Caption)
			RETURN .F.
		ENDIF
	ENDPROC


	PROCEDURE Unload
		RELEASE goFrm
	ENDPROC


	PROCEDURE ShowDiagram
		LPARAMETERS tcPath
		IF VARTYPE(tcPath) # 'C' OR EMPTY(tcPath)
			MESSAGEBOX("ShowDiagram(): error type arg";
				,16, ThisForm.Caption)
			RETURN .F.
		ENDIF
		WITH ThisForm
			IF !.IsMsChart()
				RETURN .F.
			ENDIF
			.oSession.cPath = tcPath
			IF !.oSession.FillData()
				RETURN .F.
			ENDIF
			SET DATASESSION TO (.oSession.DataSessionID)
			IF !USED(.oSession.cResultAlias)
				MESSAGEBOX("Not found cursor: '" ;
					+ .oSession.cResultAlias + "'", 16, .Caption)
				RETURN .F.
			ENDIF
			SELECT (.oSession.cResultAlias)
		ENDWITH
		LOCAL lnRows as Number, lnRow As Integer
		CALCULATE CNT() TO lnRows
		lnRow = 0 
		IF lnRows > 0 
			WITH ThisForm.Olecontrol1.oBJECT
				.ChartType = N_CUR_CHARTYPE
				.ColumnCount = 2
			    .RowCount = lnRows
				SCAN
					lnRow = lnRow+1  
					.Row = lnRow
					.Column = 1
					.Data = prcXml
					.Column = 2
					.Data = prcXmlXsd
					.RowLabel = PROPER(JUSTSTEM(RTRIM(cName))) 
				ENDSCAN
				WITH .Plot.SeriesCollection
					.Item(1).LegendText = "Xml only"
					.Item(2).LegendText = "Xml+Xsd"
				ENDWITH	
				WITH .Legend.Location
					.LocationType = N_CUR_LOCATIONTYPE
					.Visible = .T.
				ENDWITH	
			ENDWITH
			ThisForm.Caption = C_FRM_CAPTION ;
				+ ' (in '+ LOWER(ThisForm.oSession.cPath) + ')'
		ELSE
			MESSAGEBOX("Not found dbf-files in folder: '";
				+ ThisForm.oSession.cPath + "'";
				,64, ThisForm.Caption)
			RETURN .F.
		ENDIF
	ENDPROC


	PROCEDURE Init
		WITH ThisForm
			IF !.IsMsChart()
				RETURN .F.
			ENDIF
			.cPath = C_PATH_DATA
			.Resize()
		ENDWITH
	ENDPROC


	PROCEDURE Resize
		WITH ThisForm
			IF VARTYPE(.oSession) # 'O'
				RETURN
			ENDIF
			IF TYPE('ThisForm.Olecontrol1') # 'O' OR ISNULL(.Olecontrol1)
				RETURN
			ENDIF
			.LockScreen = .T. 
			IF .Height < .nMinHeight
				.Height = .nMinHeight
			ENDIF
			IF .Width < .nMinWidth
				.Width = .nMinWidth
			ENDIF
			.Olecontrol1.Height = .Height - .Olecontrol1.Top - 2
			.Olecontrol1.Width = .Width - 2*.Olecontrol1.Left
			.cmdExit.Left =  .Width - .cmdExit.Width - 2
			.LockScreen = .F. 
		ENDWITH
	ENDPROC


	PROCEDURE Load
		WITH ThisForm
			.oSession = NEWOBJECT(C_CLS_SESSION)
			IF VARTYPE(.oSession) # 'O'
				MESSAGEBOX("Can not create object: '" ;
					+ C_CLS_SESSION + "'", 16, .Caption)
				RETURN .F.
			ENDIF
		ENDWITH
	ENDPROC


	PROCEDURE cPath_Assign
		LPARAMETERS vNewVal
		WITH this
			IF !EMPTY(m.vNewVal) AND .ShowDiagram(LOWER(m.vNewVal))
				.cPath = m.vNewVal
			ENDIF
		ENDWITH 
	ENDPROC


	PROCEDURE cmdChangeDir.Click
		ThisForm.cPath = LOWER(GETDIR())
	ENDPROC


	PROCEDURE cmdExit.Click
		ThisForm.Release() 
	ENDPROC


ENDDEFINE



DEFINE CLASS DbfVsXml as Session

	cPath = C_PATH_DATA
	cResultAlias = C_RESULT_DATA
	cAliasData = ""
	PROTECTED cOldPath
	PROTECTED cOldSetDel
	PROTECTED cOldSetComp
	PROTECTED cOldSetExclus
	PROTECTED cDataFile


	PROCEDURE Init(tcPath as String) as Boolean
		IF VERSION(5) < 700
			MESSAGEBOX("Sorry, this test for VFP 7.0 or later.";
				,16, _SCREEN.Caption)
			RETURN .F. 
		ENDIF
		WITH this
			.cOldPath = FULLPATH(CURDIR())
			.cOldSetComp = SET("Compatible")
			.cOldSetDel = SET("Deleted")
			.cOldSetExclus = SET("Exclusive")  
			.cResultAlias = C_RESULT_DATA 
			IF VARTYPE(tcPath) = 'C' AND !EMPTY(tcPath)
				.cPath = tcPath
			ENDIF
			IF !EMPTY(.cPath) AND !.IsDirectory(.cPath)
				RETURN .F.
			ENDIF
		ENDWITH		
	ENDPROC


	PROTECTED FUNCTION IsDirectory(tcDir as String) as Boolean
		IF !DIRECTORY(tcDir)
			MESSAGEBOX("Not found folder: '" ;
				+ tcDir + "'", 16, _SCREEN.Caption)
			RETURN .F.
		ENDIF	
	ENDFUNC 


	PROTECTED FUNCTION CreateCursor() as Boolean
		LOCAL lcFile
		WITH this
			.DeleteCursor()
			.cAliasData = "_"+SUBSTR(SYS(2015), 4)		
			.cDataFile = LOWER(ADDBS(SYS(2023)) + .cAliasData+'.dbf')
			IF !FILE(.cDataFile)
				CREATE DBF (.cDataFile) FREE ;
					(cName M, nDbfSize I, nStrSize I, nXmlSize I, nXmlXsd I)   
			ENDIF
			IF !FILE(.cDataFile)
				MESSAGEBOX("Can not create file: '" ;
					+ .cDataFile + "'", 16, _SCREEN.Caption)
				RETURN .F.
			ENDIF
		ENDWITH	
	ENDFUNC


	FUNCTION FillData() as Boolean
		WITH this
			IF !.IsDirectory(.cPath)
				RETURN .F.
			ENDIF
			IF !.CreateCursor()
				RETURN .F.
			ENDIF
		ENDWITH
		SET DEFAULT TO (this.cPath)
		LOCAL lcSetComp AS String;
			,lcSetDel As String;
			,lcSetExcl As String   
		IF SET("Compatible") # 'ON' 
			SET COMPATIBLE ON 
			lcSetComp = 'OFF'
		ELSE
			lcSetComp = 'ON'
		ENDIF	
		IF SET("Deleted") # 'ON' 
			SET DELETED ON 
			lcSetDel = 'OFF'
		ELSE
			lcSetDel = 'ON'
		ENDIF
		IF SET("Exclusive") # 'OFF' 	
			SET EXCLUSIVE OFF
			lcSetExcl = 'ON'
		ELSE
			lcSetExcl = 'OFF'
		ENDIF	  
		LOCAL lcCurFile as String;
			,lcFptFile as String;
			,lcCurAlias as String; 
			,lcXml as String;
			,lbRetVal as Boolean 
		lcXml = '' 
		lbRetVal = .T.
		lcCurFile = LOWER(SYS(2000, '*.dbf'))
		DO WHILE !EMPTY(lcCurFile)
			lcFptFile = FORCEEXT(lcCurFile, 'fpt')
			lcCurAlias = JUSTSTEM(lcCurFile)
			IF !USED(lcCurAlias)
				USE (lcCurFile) IN 0 SHARED NOUPDATE  
				IF !USED(lcCurAlias)
					MESSAGEBOX("Can not open file: '" ;
						+ lcCurFile + "'", 16, _SCREEN.Caption)
					lbRetVal = .F.
					EXIT
				ENDIF
			ENDIF
			SELECT (lcCurAlias)
			IF FILE(lcFptFile)
				INSERT INTO (this.cAliasData) (cName, nDbfSize, nStrSize, nXmlSize, nXmlXsd) ;
					VALUES (lcCurFile, FSIZE(lcCurFile) + FSIZE(lcFptFile);
					,LENC(FILETOSTR(lcFptFile)) + LENC(FILETOSTR(lcCurFile));
					,CURSORTOXML(lcCurAlias, 'lcXml', N_XML_FORMAT, N_XML_FLAGS);
					,CURSORTOXML(lcCurAlias, 'lcXml', N_XML_FORMAT, N_XML_FLAGS, 0, "1"))
			ELSE	
				INSERT INTO (this.cAliasData) (cName, nDbfSize, nStrSize, nXmlSize, nXmlXsd) ;
					VALUES (lcCurFile, FSIZE(lcCurFile);
					,LENC(FILETOSTR(lcCurFile));
					,CURSORTOXML(lcCurAlias, 'lcXml', N_XML_FORMAT, N_XML_FLAGS);
					,CURSORTOXML(lcCurAlias, 'lcXml', N_XML_FORMAT, N_XML_FLAGS, 0, "1"))
			ENDIF
			USE IN (lcCurAlias)
			lcCurFile = LOWER(SYS(2000, '*.dbf', 1))
		ENDDO 
		lcXml = '' 
		IF SET("Compatible") # lcSetComp
			SET COMPATIBLE &lcSetComp
		ENDIF
		IF SET("Deleted") # lcSetDel
			SET DELETED &lcSetDel 
		ENDIF	
		IF SET("Exclusive") # lcSetExcl
			SET EXCLUSIVE &lcSetExcl
		ENDIF	  
		IF lbRetVal
			SELECT cname ;
				,((nXmlSize + 0.00)/(nDbfSize + 0.00))*100.00 as prcXml;
				,((nXmlXsd + 0.00)/(nDbfSize + 0.00))*100.00 as prcXmlXsd;
				FROM (this.cAliasData) INTO CURSOR (this.cResultAlias)
		ENDIF
		RETURN lbRetVal	 
	ENDFUNC


	PROTECTED FUNCTION DeleteCursor() as Boolean
		WITH this
			IF !EMPTY(.cAliasData) AND USED(.cAliasData)
				USE IN (.cAliasData)
			ENDIF
			IF !EMPTY(.cDataFile) AND FILE(.cDataFile)
				ERASE (.cDataFile)
			ENDIF
			IF !EMPTY(.cDataFile)
				LOCAL lcFptFile as String
				lcFptFile = FORCEEXT(.cDataFile, 'fpt')
				IF FILE(lcFptFile)
					ERASE (lcFptFile)
				ENDIF
			ENDIF
			IF !EMPTY(.cResultAlias) AND USED(.cResultAlias)
				USE IN (.cResultAlias)
			ENDIF
		ENDWITH	
	ENDFUNC


	PROCEDURE Destroy()
		WITH this
			.DeleteCursor()
			IF !EMPTY(.cOldPath)
				SET DEFAULT TO (.cOldPath)
			ENDIF
			LOCAL lcOldSet AS String
			IF .cOldSetComp # SET("Compatible")
				lcOldSet = .cOldSetComp
				SET COMPATIBLE &lcOldSet
			ENDIF
			IF .cOldSetDel # SET("Deleted")
				lcOldSet = .cOldSetDel
				SET DELETED &lcOldSet
			ENDIF
			IF .cOldSetExclus # SET("Exclusive")
				lcOldSet = .cOldSetExclus
				SET EXCLUSIVE &lcOldSet
			ENDIF
		ENDWITH 
		CLOSE DATABASES ALL 
	ENDPROC 

	
ENDDEFINE